import '/flutter_flow/flutter_flow_util.dart';
import '/on_boarding/on_boarding_beta/sign_in_component/sign_in_component_widget.dart';
import '/on_boarding/on_boarding_beta/sign_up_component/sign_up_component_widget.dart';
import '/on_boarding/on_boarding_beta/welcome_component/welcome_component_widget.dart';
import 'on_boarding_page_widget.dart' show OnBoardingPageWidget;
import 'package:flutter/material.dart';

class OnBoardingPageModel extends FlutterFlowModel<OnBoardingPageWidget> {
  ///  Local state fields for this page.

  String toggleIdx = 'welcome';

  ///  State fields for stateful widgets in this page.

  final unfocusNode = FocusNode();
  // Model for signInComponent component.
  late SignInComponentModel signInComponentModel;
  // Model for signUpComponent component.
  late SignUpComponentModel signUpComponentModel;
  // Model for welcomeComponent component.
  late WelcomeComponentModel welcomeComponentModel;

  @override
  void initState(BuildContext context) {
    signInComponentModel = createModel(context, () => SignInComponentModel());
    signUpComponentModel = createModel(context, () => SignUpComponentModel());
    welcomeComponentModel = createModel(context, () => WelcomeComponentModel());
  }

  @override
  void dispose() {
    unfocusNode.dispose();
    signInComponentModel.dispose();
    signUpComponentModel.dispose();
    welcomeComponentModel.dispose();
  }

  /// Action blocks.
  Future toggleOnBoardingActionPage(
    BuildContext context, {
    required String? toggleValue,
  }) async {
    toggleIdx = toggleValue!;
  }
}
